/*
$Log: filebox.h,v $
Revision 3.2.1.1  2000/12/18 08:21:48  shelton
Import slightly modified sources of ITK yui project. made by Sergey Rozenfeld.

Revision 3.1.15.1  2000/12/18 08:21:48  shelton
Import original yui sources, patched only for succesful compilation on
FreeBSD

Revision 1.4  1999/10/23 20:26:39  serg
terminfo support

Revision 1.3  1998/05/04 17:07:46  serg
       X-window system
CVS:
CVS:

Revision 1.2  1998/04/15 17:40:35  serg
Ported to Solaris-2.6-x86
CVS:
CVS:

Revision 1.1  1997/08/01 17:45:22  paul
initial

*/
#ifndef _FILEBOX_H
#define _FILEBOX_H

#include "modal.h"
#include "listbox.h"
#include "dir.h"

#ifdef DJGPP
extern void convertPath( char *path, int c1, int c2 );
#endif

class filebox : public Dialog
{
protected:
   directory *d;
   listBox *lb;
   inputLine *il;
   static int fileSortOrder;
   char *outname, *outpath, *outmask, *d_path, *d_mask;
   char *str, *oldname, *item_info;
   int cur, d_sort;
   int newname();
   int newpath();
   void fillItem( fileItem *f );
   void fillBox();
   long sizeall;
   int flagDirs;
   uid_t uid;
   gid_t gid;

public:
   filebox( char *Path, char *Mask="*", char *outn=0, char *outp=0, char *outm=0 );
   ~filebox();
   virtual void resizeScreen( Rect &old );
   virtual int 	isType(long typ);
   static char filePath[MAXPATHLEN];
   static char fileMask[128];

   virtual int init( void *data=0 );
   virtual int draw( int Redraw=0, int sy=0, int sx=0 );
   virtual long handleKey( long key, void *&ptr );
   char *getPath();
   char *getMask();
   char *getName();
   int resort();

   static Collection fileHistory;
};

#endif
