/*
$Log: keymap.h,v $
Revision 3.2.1.1  2000/12/18 08:21:48  shelton
Import slightly modified sources of ITK yui project. made by Sergey Rozenfeld.

Revision 3.1.15.1  2000/12/18 08:21:48  shelton
Import original yui sources, patched only for succesful compilation on
FreeBSD

Revision 1.2  1998/04/15 17:40:37  serg
Ported to Solaris-2.6-x86
CVS:
CVS:

Revision 1.1  1997/08/01 17:45:23  paul
initial

*/
#ifndef _KEYMAP_H
#define _KEYMAP_H

#include <stdlib.h>
#include <langs.h>

//    
enum InputType { INPUT, INT, U_INT, FLOAT, U_FLOAT, DATE };

struct CommandDescr
{
   long command;
   Lang *descr;
   ~CommandDescr() { if ( descr ) delete descr; }
};

extern int qsort_compare( const void *key1, const void *key2 );
extern int qsort_compare2( const void *key1, const void *key2 );

class Keymap
{
public:
   Keymap( long *m=0, Lang *mIdent=0 );
   ~Keymap();
   long *mas;		// sorted by key
   long *mas2;		// sorted by command
   int len, size;
   Lang *mapIdent;
   void init( long *m );
   long translate( long key );
   long getKey( long command );
};

/*-------------------------------------------------------------*/
class KeyHolder
{
public:
   Keymap **kmas;
   CommandDescr **descr;
   char **ident;
   int len;
   int add( Keymap *km, CommandDescr *cd=0 );
   int del( Keymap *km );
   Keymap *item( int index );
   void changeDescr( Keymap *km, CommandDescr *cd );
   long translate( long key );
   KeyHolder();
   ~KeyHolder();
};

#endif
