/*
$Log: visual.h,v $
Revision 3.2.1.1  2000/12/18 08:21:49  shelton
Import slightly modified sources of ITK yui project. made by Sergey Rozenfeld.

Revision 3.1.15.1  2000/12/18 08:21:49  shelton
Import original yui sources, patched only for succesful compilation on
FreeBSD

Revision 1.1  1997/08/01 17:45:26  paul
initial

*/
#ifndef _VISUAL_H
#define _VISUAL_H

#include "collect.h"
#include "point.h"

struct bound
{
   int top;
   int bott;
   ccIndex index;
   bound( int t, int b, ccIndex i ) : top(t), bott(b), index(i) {;}
};

class visual : public SortedCollection
{
protected:
   void freeItem( void *item ) { delete (bound*)item; }
   int compare( void *p1, void *p2 );
   int separator( ccIndex index, int pos );
   bound **it;
   static bound B;

public:
   visual() : SortedCollection(50,50) { duplicates=1; }
   virtual ~visual() { freeAll(); }
   void add( int top, int bott, ccIndex index );
   void remove( int top, int bott, ccIndex index );
   void region( int top, int bott, int *map );
};

#endif
